X2Go Bug report logs - #820
Fwd: [X2Go-Dev] Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal

Package: x2goserver; Maintainer for x2goserver is X2Go Developers <x2go-dev@lists.x2go.org>; Source for x2goserver is src:x2goserver.

Reported by: Rok Mandeljc <rok.mandeljc@gmail.com>

Date: Tue, 17 Mar 2015 05:45:02 UTC

Severity: normal

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#820; Package x2goserver. (Tue, 17 Mar 2015 05:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mihai Moldovan <ionic@ionic.de>:
New Bug report received and forwarded. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 17 Mar 2015 05:45:02 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.x2go.org (full text, mbox):

From: Mihai Moldovan <ionic@ionic.de>
To: submit@bugs.x2go.org, Rok Mandeljc <rok.mandeljc@gmail.com>
Subject: Fwd: [X2Go-Dev] Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal
Date: Tue, 17 Mar 2015 06:41:10 +0100
[Message part 1 (text/plain, inline)]
Package: x2goserver
Version 4.0.1.19
Tag: patch
Submitter: Rok Mandeljc <rok.mandeljc@gmail.com>


-------- Forwarded Message --------
Subject: 	[X2Go-Dev] Patch: x2goserver: x2goruncommand - set
IMEXIT="true" for gnome-terminal
Date: 	Mon, 16 Mar 2015 23:01:05 +0100
From: 	Rok Mandeljc <rok.mandeljc@gmail.com>
To: 	x2go-dev@lists.x2go.org



Hello,

I have been trying to set up x2goserver on my Fedora 21 boxes, and
gnome-terminal seems to be failing with symptoms similar to those
described in #268.

It seems that x2goruncommand has been reworked a bit since that patch,
and now attempts to force the forking programs to stay in the foreground
by capturing their output to STDOUT. Unfortunately, this does not seem
to work for gnome-terminal; the terminal window appears on the client
for a second, then closes and the session is proclaimed to be finished.
This can be fixed by explicitly setting IMEXIT="true" if called binary
is gnome-terminal, which is done by the attached patch.

Regards,
    Rok





[0001-x2goruncommand-set-IMEXIT-true-if-called-binary-is-g.patch (text/x-patch, attachment)]
[Attached Message Part (text/plain, attachment)]
[signature.asc (application/pgp-signature, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#820; Package x2goserver. (Tue, 17 Mar 2015 06:05:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mihai Moldovan <ionic@ionic.de>, 820@bugs.x2go.org:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 17 Mar 2015 06:05:02 GMT) Full text and rfc822 format available.

Message #10 received at 820@bugs.x2go.org (full text, mbox):

From: Mihai Moldovan <ionic@ionic.de>
To: Rok Mandeljc <rok.mandeljc@gmail.com>, 820@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#820: Fwd: Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal
Date: Tue, 17 Mar 2015 07:02:31 +0100
[Message part 1 (text/plain, inline)]
Control: submitter -1 Rok Mandeljc <rok.mandeljc@gmail.com>
Thanks


On 17.03.2015 06:41 AM, Mihai Moldovan wrote:
> I have been trying to set up x2goserver on my Fedora 21 boxes, and
> gnome-terminal seems to be failing with symptoms similar to those
> described in #268.
>
> It seems that x2goruncommand has been reworked a bit since that patch,
> and now attempts to force the forking programs to stay in the foreground
> by capturing their output to STDOUT. Unfortunately, this does not seem
> to work for gnome-terminal; the terminal window appears on the client
> for a second, then closes and the session is proclaimed to be finished.
> This can be fixed by explicitly setting IMEXIT="true" if called binary
> is gnome-terminal, which is done by the attached patch.

This looked weird at first glance, because you've previously (two years
ago) sent a patch to explicitly disable IMEXIT for GNOME Terminal.

However, Mike#1 changed the IMEXIT behavior with commit
c3afe1c154dfeb0ba052f7506f0cadc5f6c62871 and that's also why it's now
failing for GNOME Terminal.

I'll be adding IMEXIT="true" and your comment where gnome-terminal is
defined, if that's OK with you?

Will craft and commit a patch tomorrow.

Thanks for contributing!



Mihai


N.B.: shouldn't this be also required for KDE4's konsole? Looks like it,
but I'm not a KDE user, so... input welcome.

[signature.asc (application/pgp-signature, attachment)]

Changed Bug submitter to 'Rok Mandeljc <rok.mandeljc@gmail.com>' from 'Mihai Moldovan <ionic@ionic.de>' Request was from Mihai Moldovan <ionic@ionic.de> to 820-submit@bugs.x2go.org. (Tue, 17 Mar 2015 06:05:02 GMT) Full text and rfc822 format available.

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#820; Package x2goserver. (Tue, 17 Mar 2015 10:10:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Rok Mandeljc <rok.mandeljc@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 17 Mar 2015 10:10:02 GMT) Full text and rfc822 format available.

Message #17 received at 820@bugs.x2go.org (full text, mbox):

From: Rok Mandeljc <rok.mandeljc@gmail.com>
To: Mihai Moldovan <ionic@ionic.de>, 820@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#820: Fwd: Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal
Date: Tue, 17 Mar 2015 11:09:02 +0100
On 17. 03. 2015 07:02, Mihai Moldovan wrote:
> Control: submitter -1 Rok Mandeljc <rok.mandeljc@gmail.com>
> Thanks
>
>
> On 17.03.2015 06:41 AM, Mihai Moldovan wrote:
>> I have been trying to set up x2goserver on my Fedora 21 boxes, and
>> gnome-terminal seems to be failing with symptoms similar to those
>> described in #268.
>>
>> It seems that x2goruncommand has been reworked a bit since that patch,
>> and now attempts to force the forking programs to stay in the foreground
>> by capturing their output to STDOUT. Unfortunately, this does not seem
>> to work for gnome-terminal; the terminal window appears on the client
>> for a second, then closes and the session is proclaimed to be finished.
>> This can be fixed by explicitly setting IMEXIT="true" if called binary
>> is gnome-terminal, which is done by the attached patch.
> This looked weird at first glance, because you've previously (two years
> ago) sent a patch to explicitly disable IMEXIT for GNOME Terminal.
>
> However, Mike#1 changed the IMEXIT behavior with commit
> c3afe1c154dfeb0ba052f7506f0cadc5f6c62871 and that's also why it's now
> failing for GNOME Terminal.

Indeed :)

> I'll be adding IMEXIT="true" and your comment where gnome-terminal is
> defined, if that's OK with you?

If you are talking about the if [ "$cmd" == "TERMINAL" ] switch, then I
think it will not fix the case when session is "single command" and the
"gnome-terminal" is manually entered as a binary (with or without path).
I use such session definition on couple of workstations that have both
KDE and GNOME installed to get gnome-terminal instead of konsole... Not
sure how wide-spread that use case is, though; or if it could perhaps be
done better?

>
> Will craft and commit a patch tomorrow.
>
> Thanks for contributing!
>
>
>
> Mihai
>
>
> N.B.: shouldn't this be also required for KDE4's konsole? Looks like it,
> but I'm not a KDE user, so... input welcome.

Capturing konsole's output to STDOUT seems to do the trick, at least at
the moment. So for now, it works correctly without setting IMEXIT.

Regards,
    Rok


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#820; Package x2goserver. (Tue, 17 Mar 2015 14:45:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mihai Moldovan <ionic@ionic.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 17 Mar 2015 14:45:01 GMT) Full text and rfc822 format available.

Message #22 received at 820@bugs.x2go.org (full text, mbox):

From: Mihai Moldovan <ionic@ionic.de>
To: Rok Mandeljc <rok.mandeljc@gmail.com>, 820@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#820: Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal
Date: Tue, 17 Mar 2015 15:43:15 +0100
[Message part 1 (text/plain, inline)]
On 17.03.2015 11:09 AM, Rok Mandeljc wrote:
> On 17. 03. 2015 07:02, Mihai Moldovan wrote:
> [...]
>> I'll be adding IMEXIT="true" and your comment where gnome-terminal is
>> defined, if that's OK with you?
> If you are talking about the if [ "$cmd" == "TERMINAL" ] switch, then I
> think it will not fix the case when session is "single command" and the
> "gnome-terminal" is manually entered as a binary (with or without path).
> I use such session definition on couple of workstations that have both
> KDE and GNOME installed to get gnome-terminal instead of konsole... Not
> sure how wide-spread that use case is, though; or if it could perhaps be
> done better?

Yes, you're right and that makes sense.

As a side note, luckily, published applications are always handled with
IMEXIT, so these are good.


>> [...]
>> N.B.: shouldn't this be also required for KDE4's konsole? Looks like it,
>> but I'm not a KDE user, so... input welcome.
> Capturing konsole's output to STDOUT seems to do the trick, at least at
> the moment. So for now, it works correctly without setting IMEXIT.

OK, thanks!


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#820; Package x2goserver. (Tue, 17 Mar 2015 16:10:01 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 17 Mar 2015 16:10:02 GMT) Full text and rfc822 format available.

Message #27 received at 820@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: Mihai Moldovan <ionic@ionic.de>, 820@bugs.x2go.org, Rok Mandeljc <rok.mandeljc@gmail.com>
Subject: Re: [X2Go-Dev] Bug#820: Bug#820: Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal
Date: Tue, 17 Mar 2015 16:05:03 +0000
[Message part 1 (text/plain, inline)]
Hi all,

On  Di 17 Mär 2015 15:43:15 CET, Mihai Moldovan wrote:

> On 17.03.2015 11:09 AM, Rok Mandeljc wrote:
>> On 17. 03. 2015 07:02, Mihai Moldovan wrote:
>> [...]
>>> I'll be adding IMEXIT="true" and your comment where gnome-terminal is
>>> defined, if that's OK with you?
>> If you are talking about the if [ "$cmd" == "TERMINAL" ] switch, then I
>> think it will not fix the case when session is "single command" and the
>> "gnome-terminal" is manually entered as a binary (with or without path).
>> I use such session definition on couple of workstations that have both
>> KDE and GNOME installed to get gnome-terminal instead of konsole... Not
>> sure how wide-spread that use case is, though; or if it could perhaps be
>> done better?
>
> Yes, you're right and that makes sense.
>
> As a side note, luckily, published applications are always handled with
> IMEXIT, so these are good.
>
>
>>> [...]
>>> N.B.: shouldn't this be also required for KDE4's konsole? Looks like it,
>>> but I'm not a KDE user, so... input welcome.
>> Capturing konsole's output to STDOUT seems to do the trick, at least at
>> the moment. So for now, it works correctly without setting IMEXIT.
>
> OK, thanks!

With gnome-terminal from GNOMEv2 IMEXIT needs to be false (because  
gnome-terminal (v2) does _not_ fork to background).

With gnome-terminal from GNOMEv3 IMEXIT needs to be true (because  
gnome-terminal (v3) forks to background).

Mike
-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#820; Package x2goserver. (Fri, 20 Mar 2015 04:55:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mihai Moldovan <ionic@ionic.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Fri, 20 Mar 2015 04:55:02 GMT) Full text and rfc822 format available.

Message #32 received at 820@bugs.x2go.org (full text, mbox):

From: Mihai Moldovan <ionic@ionic.de>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>, 820@bugs.x2go.org, Rok Mandeljc <rok.mandeljc@gmail.com>
Subject: Re: [X2Go-Dev] Bug#820: Bug#820: Bug#820: Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal
Date: Fri, 20 Mar 2015 05:53:09 +0100
[Message part 1 (text/plain, inline)]
On 17.03.2015 05:05 PM, Mike Gabriel wrote:
> With gnome-terminal from GNOMEv2 IMEXIT needs to be false (because
> gnome-terminal (v2) does _not_ fork to background).
>
> With gnome-terminal from GNOMEv3 IMEXIT needs to be true (because
> gnome-terminal (v3) forks to background).

Stefan just "submitted" another bug report yesterday in a private
conversion about another piece of software that needs special handling
via IMEXIT -- but likewise different values dependent on the specific
version used.

I guess I should better handle that with a few new functions, to be able
to add other software and versions more flexible in the future.



Mihai

P.S.: a workaround for those issues is to use pubapps.


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#820; Package x2goserver. (Fri, 20 Mar 2015 11:20:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Fri, 20 Mar 2015 11:20:02 GMT) Full text and rfc822 format available.

Message #37 received at 820@bugs.x2go.org (full text, mbox):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: Mihai Moldovan <ionic@ionic.de>
Cc: 820@bugs.x2go.org, Rok Mandeljc <rok.mandeljc@gmail.com>
Subject: Re: [X2Go-Dev] Bug#820: Bug#820: Bug#820: Patch: x2goserver: x2goruncommand - set IMEXIT="true" for gnome-terminal
Date: Fri, 20 Mar 2015 11:17:15 +0000
[Message part 1 (text/plain, inline)]
On  Fr 20 Mär 2015 05:53:09 CET, Mihai Moldovan wrote:

> On 17.03.2015 05:05 PM, Mike Gabriel wrote:
>> With gnome-terminal from GNOMEv2 IMEXIT needs to be false (because
>> gnome-terminal (v2) does _not_ fork to background).
>>
>> With gnome-terminal from GNOMEv3 IMEXIT needs to be true (because
>> gnome-terminal (v3) forks to background).
>
> Stefan just "submitted" another bug report yesterday in a private
> conversion about another piece of software that needs special handling
> via IMEXIT -- but likewise different values dependent on the specific
> version used.
>
> I guess I should better handle that with a few new functions, to be able
> to add other software and versions more flexible in the future.
>
>
>
> Mihai
>
> P.S.: a workaround for those issues is to use pubapps.

Before you start working on this...

Actually, the x2goruncommand stuff should be fully reworked. So that  
TERMINAL, WEBBROWSER etc. are actually symlinks or .desktop files that  
the x2goruncommand refers to.

Basically, I would fork every single application to background and  
monitor its termination with other means (e.g. with the stdout/stderr  
blocker), so that IMEXIT would always be FALSE.

Mike
-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Send a report that this bug log contains spam.


X2Go Developers <owner@bugs.x2go.org>. Last modified: Tue Dec 11 00:24:54 2018; Machine Name: ymir.das-netzwerkteam.de

X2Go Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.